/*
GPS Demo using the Defines header.
3/22/09
By TJ Johnson

This program parses the avliable NEMA string data from a GPS unit and displays 
it to the terminal at a baud of 57600. 

The terminal display is optimized for the PST terminal avliable from parallax's 
website.

For use with the parallax GPS unit, the /raw pin should be connected to ground.

See end of file for MIT License.

*/
#include <propeller.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <asio.h>
#include "gpsParserDefinesHeader.h"



// Global Constants
const int GPS_PIN = 0;

// function prototypes
char* validToString(int input);





// Global Variables

char validStr[10];


//Main function
main()
{
wait(80000000); // Wait a second before starting the program.
asio_init(57600); // Start the terminal at 57600 baud.

gpsStart(GPS_PIN); // Start the gps driver
while(1) // Forever repeating loop
{


putchar(0); // clear the screen

// Print each of the avliable data from the gps to the terminal.
// The 13 is a CR return character, for use with the ICCV7 termial replace 13 
// with '/n' for a new line command.
printf("The date is : %d/%d/%d %c", getGpsMonth(),getGpsDay(), getGpsYear(), 13);
printf("The Time is : %d:%d:%d %c", getGpsTimeHours(),getGpsTimeMin(), getGpsTimeSec(), 13);
printf("The signal is : %d  - %s %c", gpsValid ,validToString(gpsValid), 13);
printf("The latitude in DMS is : %d %d' %d'' %c", gpsLatDeg, gpsLatMin, gpsLatSec, 13);
printf("The latitude in Deg Decimal Minutes is : %d %f %c", gpsLatDeg, gpsLatDecMin, 13);
printf("The orginal string read was : %s %c", gpsLatStr, 13);
printf("The longitude in DMS is : %d %d' %d'' %c", gpsLongDeg ,gpsLongMin, gpsLongSec, 13);
printf("The longitude in Deg Decimal Minutes is : %d %f %c", gpsLongDeg, gpsLongDecMin, 13);
printf("The orginal string read was : %s %c", gpsLongStr, 13);

printf("The speed(knots) is : %d.%d as a float : %f %c",gpsSpeed, gpsSpeedTenths ,gpsSpeedFloat, 13);
printf("The heading is : %d.%d as a float : %f %c", gpsHeadingDeg, gpsHeadingTenths, gpsHeadingFloat, 13);
printf("The altitude(meters) is : %d.%d as a float : %f %c", gpsAlt, gpsAltTenths, gpsAltFloat, 13);
printf("The number of sats in view is : %d %c", gpsSats, 13);



// wait 1 second before clearing and updating the data.
wait(80000000);

}


return 0;
}





char* validToString(int input)
  {
  // This function simpily returns a string based on true or false result
  if (input == 1) // if the signal is good, move valid to the string to be printed.
    {
	strcpy(validStr, "Valid"); // Copy the string
    }
  else // if the signal is not valid, move invalid to the string.
    {
	strcpy(validStr, "Invalid"); // Copy the string
	}
	
	return validStr; // return the copied string.
  }	

  /*
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
*/